package com.hotwj.platform.config.riskScoreLevel.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import com.hotwj.platform.config.riskScoreLevel.domain.bo.HotRiskScoreLevelBo;
import com.hotwj.platform.config.riskScoreLevel.domain.vo.HotRiskScoreLevelVo;
import com.hotwj.platform.config.riskScoreLevel.domain.HotRiskScoreLevel;
import com.hotwj.platform.config.riskScoreLevel.mapper.HotRiskScoreLevelMapper;
import com.hotwj.platform.config.riskScoreLevel.service.IHotRiskScoreLevelService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 风险等级划分Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-04
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotRiskScoreLevelServiceImpl implements IHotRiskScoreLevelService {

    private final HotRiskScoreLevelMapper baseMapper;

    /**
     * 查询风险等级划分
     *
     * @param id 主键
     * @return 风险等级划分
     */
    @Override
    public HotRiskScoreLevelVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询风险等级划分列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 风险等级划分分页列表
     */
    @Override
    public TableDataInfo<HotRiskScoreLevelVo> queryPageList(HotRiskScoreLevelBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotRiskScoreLevel> lqw = buildQueryWrapper(bo);
        Page<HotRiskScoreLevelVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的风险等级划分列表
     *
     * @param bo 查询条件
     * @return 风险等级划分列表
     */
    @Override
    public List<HotRiskScoreLevelVo> queryList(HotRiskScoreLevelBo bo) {
        LambdaQueryWrapper<HotRiskScoreLevel> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotRiskScoreLevel> buildQueryWrapper(HotRiskScoreLevelBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotRiskScoreLevel> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotRiskScoreLevel::getId);
        lqw.eq(bo.getMinScore() != null, HotRiskScoreLevel::getMinScore, bo.getMinScore());
        lqw.eq(bo.getMaxScore() != null, HotRiskScoreLevel::getMaxScore, bo.getMaxScore());
        lqw.like(StringUtils.isNotBlank(bo.getLevelName()), HotRiskScoreLevel::getLevelName, bo.getLevelName());
        lqw.eq(bo.getIsDeleted() != null, HotRiskScoreLevel::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增风险等级划分
     *
     * @param bo 风险等级划分
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotRiskScoreLevelBo bo) {
        HotRiskScoreLevel add = MapstructUtils.convert(bo, HotRiskScoreLevel.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改风险等级划分
     *
     * @param bo 风险等级划分
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotRiskScoreLevelBo bo) {
        HotRiskScoreLevel update = MapstructUtils.convert(bo, HotRiskScoreLevel.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotRiskScoreLevel entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除风险等级划分信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
